var clock =
        {
             //Pocet poloziek, ktore sa este nacitavaju
            ItemsToLoad: 0,

            //Cache cifernika
            lastMinute: -1,
            lastMinuteData: null,

            //Obrazky
            img_line: null,
            img_second: null,
            img_minute: null,
            img_hour: null,

            //Polomer
            Radius: 0,

            //Kresliaca plocha
            Canvas: null,
            Context: null,
            ContextWidth: 0,
            ContextHeight: 0,
            Load: function ()
            {
                 //Inicializacia kresliaceho prostredia
                this.Canvas = document.getElementById('clock');
                this.Context = this.Canvas.getContext("2d");

                // Odpamatame si rozmery kresliacej plochy
                this.ContextWidth = this.Canvas.offsetWidth;
                this.ContextHeight = this.Canvas.offsetHeight;

                //Vyratame polomer cifernika
                this.Radius = this.ContextWidth / 2;

                //Nacitame obrazky
                this.img_line = this.CreateImage("line");
                this.img_second = this.CreateImage("second");
                this.img_minute = this.CreateImage("minute");
                this.img_hour = this.CreateImage("hour");
            }, 
            CreateImage: function (FileName)
            {
                var img = new Image();
                this.ItemsToLoad++;
                img.src = "imgs/" + FileName + ".png";
                img.onload = this.ImageLoaded;
                return img;
            },
            
            ImageLoaded: function ()
            {
                this.onload = null;
                clock.ItemsToLoad--;
                clock.CheckLoadedFiles();
            },
            
            CheckLoadedFiles: function ()
            {
                if (this.ItemsToLoad <= 0)
                {
                    this.ShowClock();
                }
            },
            ShowClock: function ()
            {
                this.Context.clearRect(0, 0, this.ContextWidth, this.ContextHeight);

                var actDate = new Date();

                var Minutes = actDate.getMinutes();
                var Hours = actDate.getHours();

                if (Hours >= 12)
                    Hours -= 12;

                if (this.lastMinute !== Minutes)
                {
                    for (var i = 0; i < 12; i++)
                    {
                        this.DrawElem(this.img_line, i * 30.0, this.Radius, 5);
                    }

                    var TotalHours = Hours + Minutes / 60.0;
                    this.DrawHand(this.img_hour, Math.round(360.0 / 12.0 * TotalHours, 2));

                    this.DrawHand(this.img_minute, 360.0 / 60.0 * Minutes);

                    //Ulozime obrazok do cache
                    this.lastMinute = Minutes;
                    this.lastMinuteData = this.Context.getImageData(0, 0, this.ContextWidth, this.ContextHeight);
                } 
                else
                { //Nacitame obrazku z cache
                    this.Context.putImageData(this.lastMinuteData, 0, 0);
                }

                var Seconds = actDate.getSeconds();
                this.DrawHand(this.img_second, 360.0 / 60.0 * Seconds);
                window.setTimeout("clock.ShowClock();", 1000);
                
            },
             DrawHand: function (img, degrees)
            {
                var imgHeight = img.naturalHeight;
                var imgWidth = img.naturalWidth;

                var x = this.Radius - (imgWidth / 2);
                var y = 3 + this.Radius - imgHeight;
                this.DrawElem(img, degrees, x, y);
            },
            DrawElem: function (img, degrees, x, y)
            {
                var Radiants = degrees * Math.PI / 180;

                this.Context.translate(this.Radius, this.Radius);
                this.Context.rotate(Radiants);
                this.Context.translate(-this.Radius, -this.Radius);

                this.Context.drawImage(img, x, y);

                this.Context.translate(this.Radius, this.Radius);
                this.Context.rotate(-Radiants);
                this.Context.translate(-this.Radius, -this.Radius);
            }
        };